---------------------------------------------------------------------
-- Main Lua script.
-- This script should be run by the FastCGI module.
-- It waits for a request and executes CGILua's main script (main.lua).
--
-- $Id: t_fastcgi.lua,v 1.12 2007/12/11 17:58:03 mascarenhas Exp $
---------------------------------------------------------------------

-- Kepler bootstrap
local bootstrap, err = loadfile(os.getenv("KEPLER_INIT") or [[KEPLER_INIT]])
if bootstrap then
  bootstrap()
else
  io.stderr:write(tostring(err))
  return nil
end

require"lfcgi"
require"rings"

while lfcgi.accept() >= 0 do
    local globals = RINGS_CGILUA_GLOBALS or {}
	local s = rings.new ()
	local init =[=[
	-- Kepler bootstrap
	local bootstrap, err = loadfile(os.getenv("KEPLER_INIT") or [[KEPLER_INIT]])
	if bootstrap then
	  bootstrap()
	else
	  io.stderr:write(tostring(err))
	  return nil
	end
    	local info = require"sapi.fastcgi.info"
    	local req = require"sapi.fastcgi.request"
    	local res = require"sapi.fastcgi.response"
    	SAPI = {
        	Info = info.open (),
        	Request = req.open (),
        	Response = res.open (),
    	}

	local lfcgi = require"lfcgi"
	io.stdout = lfcgi.stdout
	io.stderr = lfcgi.stderr
	io.stdin = lfcgi.stdin
]=]

    -- Alow the listed globals
    for _, v in ipairs (globals) do
        init = init..[[_, ]]..v..[[ = remotedostring("return ]]..v..[[")]].."\n"
    end
    
    init = init..[=[
    	require"cgilua"
    	return cgilua.main ()
	]=]
    local ok, ret = s:dostring (init)
	s:close ()
end

